float min(float dx, float dy)
{
  if(dx>=dy)
    return dy;
  else
    return dx;
}

#define p(x,y)  ((x)*ny+(y))
#define S MU_0/EPSILON_0
#define SQUARE(x) ((x)*(x))

#define SET_PML								  \
  s_max = -(3.5+1)*logf(10e-3)/(2*npml*dx*sqrtf(MU_0/EPSILON_0));	  \
  s_may = -(3.5+1)*logf(10e-3)/(2*npml*dy*sqrtf(MU_0/EPSILON_0));	  \
  for(i=0;i<npml;i++)							  \
  {									  \
    sx[i] = pow(((float)i+1)/(npml),3.5)*s_max;				  \
    sy[i] = pow(((float)i+1)/(npml),3.5)*s_may;				  \
  }									  \
  for(i=0;i<nx;i++)							  \
    for(j=0;j<ny;j++)							  \
    {									  \
      if(i>=npml && i<nx-npml)						  \
	sigmax[p(i,j)] = 0.0;						  \
      if(j>=npml && j<ny-npml)						  \
	sigmay[p(i,j)] = 0.0;						  \
      if(i>=nx-npml && i<nx)						  \
	sigmax[p(i,j)] = 0.0;						  \
      if(j>=ny-npml && j<ny)						  \
	sigmay[p(i,j)] = sy[j-ny+npml];					  \
      if(i>=0 && i<npml)						  \
	sigmax[p(i,j)] = 0.0;						  \
      if(j>=0 && j<npml)						  \
	sigmay[p(i,j)] = sy[npml-j-1];					  \
      }

#define E_FIELD_UPDATE									  \
  if(i==0 && j==0) {									  \
    if(node == 0) {									  \
      Ey[p(0,0)] = Ey[p(nx-1,0)]*cos(-k*R) - rE[0+ny]*sin(-k*R);			  \
    }											  \
    if(node == 1) {									  \
      Ey[p(0,0)] = rE[0+ny]*sin(-k*R) + Ey[p(nx-1,0)]*cos(-k*R);			  \
    }											  \
  }											  \
  else if(i==0){									  \
    if(node == 0) {									  \
      Ex[p(0,j)] = Ex[p(nx-1,j)]*cos(-k*R) - rE[j]*sin(-k*R);				  \
      Ey[p(0,j)] = Ey[p(nx-1,j)]*cos(-k*R) - rE[j+ny]*sin(-k*R);			  \
    }											  \
    if(node == 1) {									  \
      Ex[p(0,j)] = rE[j]*sin(-k*R) + Ex[p(nx-1,j)]*cos(-k*R);				  \
      Ey[p(0,j)] = rE[j+ny]*sin(-k*R) + Ey[p(nx-1,j)]*cos(-k*R);			  \
    }											  \
  }											  \
  else if(j==0){									  \
    Ey[p(i,j)] = (1-dt*sigmax[p(i,j)]/eperm[p(i,j)])/(1+dt*sigmax[p(i,j)]/eperm[p(i,j)])* \
      Ey[p(i,j)] - (dt/(eperm[p(i,j)]*dx))/(1+dt*sigmax[p(i,j)]/eperm[p(i,j)])*		  \
      ((Hzx[p(i,j)]+Hzy[p(i,j)])-(Hzx[p(i-1,j)]+Hzy[p(i-1,j)]))				  \
      +Py[p(i,j)]-dt*Wp[p(i,j)]*Wp[p(i,j)]*Fy[p(i,j)];					  \
  }											  \
  else{											  \
    Ex[p(i,j)] = (1-dt*sigmay[p(i,j)]/eperm[p(i,j)])/(1+dt*sigmay[p(i,j)]/eperm[p(i,j)])* \
      Ex[p(i,j)] + (dt/(eperm[p(i,j)]*dy))/(1+dt*sigmay[p(i,j)]/eperm[p(i,j)])*		  \
      ((Hzx[p(i,j)]+Hzy[p(i,j)])-(Hzx[p(i,j-1)]+Hzy[p(i,j-1)]))				  \
      +Px[p(i,j)]-dt*Wp[p(i,j)]*Wp[p(i,j)]*Fx[p(i,j)];					  \
    Ey[p(i,j)] = (1-dt*sigmax[p(i,j)]/eperm[p(i,j)])/(1+dt*sigmax[p(i,j)]/eperm[p(i,j)])* \
      Ey[p(i,j)] - (dt/(eperm[p(i,j)]*dx))/(1+dt*sigmax[p(i,j)]/eperm[p(i,j)])*		  \
      ((Hzx[p(i,j)]+Hzy[p(i,j)])-(Hzx[p(i-1,j)]+Hzy[p(i-1,j)]))				  \
      +Py[p(i,j)]-dt*Wp[p(i,j)]*Wp[p(i,j)]*Fy[p(i,j)];					  \
  }


#define H_FIELD_UPDATE									    \
  if(i==nx-1 && j==ny-1){								    \
    if(node == 0){									    \
      Hzx[p(i,j)] = Hzx[p(0,j)]*cos(k*R) - rHz[j]*sin(k*R);				    \
      Hzy[p(i,j)] = Hzy[p(0,j)]*cos(k*R) - rHz[j+ny]*sin(k*R);				    \
    }											    \
    if(node == 1){									    \
      Hzx[p(i,j)] = rHz[j]*sin(k*R) + Hzx[p(0,j)]*cos(k*R);				    \
      Hzy[p(i,j)] = rHz[j+ny]*sin(k*R) + Hzy[p(0,j)]*cos(k*R);				    \
    }											    \
  }											    \
  else if(i==nx-1){									    \
    if(node == 0){									    \
      Hzx[p(i,j)] = Hzx[p(0,j)]*cos(k*R) - rHz[j]*sin(k*R);				    \
      Hzy[p(i,j)] = Hzy[p(0,j)]*cos(k*R) - rHz[j+ny]*sin(k*R);				    \
    }											    \
    if(node == 1){									    \
      Hzx[p(i,j)] = rHz[j]*sin(k*R) + Hzx[p(0,j)]*cos(k*R);				    \
      Hzy[p(i,j)] = rHz[j+ny]*sin(k*R) + Hzy[p(0,j)]*cos(k*R);				    \
    }											    \
  }											    \
  else if(j==ny-1){									    \
    Hzx[p(i,j)] = (1-dt*S*sigmax[p(i,j)]/MU_0)/(1+dt*S*sigmax[p(i,j)]/MU_0)*Hzx[p(i,j)]	    \
      - (dt/(MU_0*dx))/(1+dt*S*sigmax[p(i,j)]/MU_0)*( Ey[p(i+1,j)]-Ey[p(i,j)] );	    \
    Hzy[p(i,j)] = (1-dt*S*sigmay[p(i,j)]/MU_0)/(1+dt*S*sigmay[p(i,j)]/MU_0)*Hzy[p(i,j)]	    \
      + (dt/(MU_0*dy))/(1+dt*S*sigmay[p(i,j)]/MU_0)*( 0 - Ex[p(i,j)] );			    \
  }											    \
  else{											    \
    Hzx[p(i,j)] = (1-dt*S*sigmax[p(i,j)]/MU_0)/(1+dt*S*sigmax[p(i,j)]/MU_0)*Hzx[p(i,j)]	    \
      - (dt/(MU_0*dx))/(1+dt*S*sigmax[p(i,j)]/MU_0)*( Ey[p(i+1,j)]-Ey[p(i,j)] );	    \
    Hzy[p(i,j)] = (1-dt*S*sigmay[p(i,j)]/MU_0)/(1+dt*S*sigmay[p(i,j)]/MU_0)*Hzy[p(i,j)]	    \
      + (dt/(MU_0*dy))/(1+dt*S*sigmay[p(i,j)]/MU_0)*( Ex[p(i,j+1)]-Ex[p(i,j)] );	    \
  }

#define F_FUNCTION_UPDATE					  \
  Fx[p(i,j)] = dt*Ex[p(i,j)]+expf(-r[p(i,j)]*dt)*Fx[p(i,j)];	  \
  Fy[p(i,j)] = dt*Ey[p(i,j)]+expf(-r[p(i,j)]*dt)*Fy[p(i,j)];		  

#define E_FIELD_SYNC						  \
  if(node == 0)							  \
  {								  \
    for(j=0;j<ny;j++)						  \
      sE[j] = Ex[p(nx-1,j)];					  \
    for(j=0;j<ny;j++)						  \
      sE[j+ny] = Ey[p(nx-1,j)];					  \
    MPI_Send(sE,2*ny,MPI_FLOAT,1,0,MPI_COMM_WORLD);		  \
    MPI_Recv(rE,2*ny,MPI_FLOAT,1,1,MPI_COMM_WORLD,&status);	  \
  }								  \
  else if(node == 1)						  \
  {								  \
    MPI_Recv(rE,2*ny,MPI_FLOAT,0,0,MPI_COMM_WORLD,&status);	  \
    for(j=0;j<ny;j++)						  \
      sE[j] = Ex[p(nx-1,j)];					  \
    for(j=0;j<ny;j++)						  \
      sE[j+ny] = Ey[p(nx-1,j)];					  \
    MPI_Send(sE,2*ny,MPI_FLOAT,0,1,MPI_COMM_WORLD);		  \
  }

#define H_FIELD_SYNC						  \
  if(node == 0)							  \
  {								  \
    MPI_Recv(rHz,2*ny,MPI_FLOAT,1,1,MPI_COMM_WORLD,&status);	  \
    for(j=0;j<ny;j++)						  \
      sHz[j] = Hzx[p(0,j)];					  \
    for(j=0;j<ny;j++)						  \
      sHz[j+ny] = Hzy[p(0,j)];					  \
    MPI_Send(sHz,2*ny,MPI_FLOAT,1,0,MPI_COMM_WORLD);		  \
  }								  \
  else if(node == 1)						  \
  {								  \
    for(j=0;j<ny;j++)						  \
      sHz[j] = Hzx[p(0,j)];					  \
    for(j=0;j<ny;j++)						  \
      sHz[j+ny] = Hzy[p(0,j)];					  \
    MPI_Send(sHz,2*ny,MPI_FLOAT,0,1,MPI_COMM_WORLD);		  \
    MPI_Recv(rHz,2*ny,MPI_FLOAT,0,0,MPI_COMM_WORLD,&status);	  \
  }

#define E_FIELD_BC_UPDATE					  \
  if(j==0){							  \
    if(node == 0) {						  \
      Ey[p(0,0)] = Ey[p(nx-1,0)]*cos(-k*R) - rE[0+ny]*sin(-k*R);  \
    }								  \
    if(node == 1) {						  \
      Ey[p(0,0)] = rE[0+ny]*sin(-k*R) + Ey[p(nx-1,0)]*cos(-k*R);  \
    }								  \
  }								  \
  else{								  \
    if(node == 0) {						  \
      Ex[p(0,j)] = Ex[p(nx-1,j)]*cos(-k*R) - rE[j]*sin(-k*R);	  \
      Ey[p(0,j)] = Ey[p(nx-1,j)]*cos(-k*R) - rE[j+ny]*sin(-k*R);  \
    }								  \
    if(node == 1) {						  \
      Ex[p(0,j)] = rE[j]*sin(-k*R) + Ex[p(nx-1,j)]*cos(-k*R);	  \
      Ey[p(0,j)] = rE[j+ny]*sin(-k*R) + Ey[p(nx-1,j)]*cos(-k*R);  \
    }								  \
  }

#define H_FIELD_BC_UPDATE					  \
    if(node == 0){						  \
      Hzx[p(nx-1,j)] = Hzx[p(0,j)]*cos(k*R) - rHz[j]*sin(k*R);	  \
      Hzy[p(nx-1,j)] = Hzy[p(0,j)]*cos(k*R) - rHz[j+ny]*sin(k*R); \
    }								  \
    if(node == 1){						  \
      Hzx[p(nx-1,j)] = rHz[j]*sin(k*R) + Hzx[p(0,j)]*cos(k*R);	  \
      Hzy[p(nx-1,j)] = rHz[j+ny]*sin(k*R) + Hzy[p(0,j)]*cos(k*R); \
    }											    

#define INIT							  \
  Ex=(float *)malloc(sizeof(float)*nx*ny);	    \
  Ey=(float *)malloc(sizeof(float)*nx*ny);	    \
  Hzx=(float *)malloc(sizeof(float)*nx*ny);	    \
  Hzy=(float *)malloc(sizeof(float)*nx*ny);	    \
  Fx=(float *)malloc(sizeof(float)*nx*ny);	    \
  Fy=(float *)malloc(sizeof(float)*nx*ny);	    \
  Wp=(float *)malloc(sizeof(float)*nx*ny);	    \
  r=(float *)malloc(sizeof(float)*nx*ny);	    \
  Px=(float *)malloc(sizeof(float)*nx*ny);	    \
  Py=(float *)malloc(sizeof(float)*nx*ny);	    \
  sE=(float *)malloc(sizeof(float)*2*ny);	    \
  sHz=(float *)malloc(sizeof(float)*2*ny);	    \
  rE=(float *)malloc(sizeof(float)*2*ny);	    \
  rHz=(float *)malloc(sizeof(float)*2*ny);	    \
  eperm=(float *)malloc(sizeof(float)*nx*ny);	    \
  einf=(float *)malloc(sizeof(float)*nx*ny);	    \
  sigmax=(float *)malloc(sizeof(float)*nx*ny);	    \
  sigmay=(float *)malloc(sizeof(float)*nx*ny);	    \
  sx=(float *)malloc(sizeof(float)*npml);	    \
  sy=(float *)malloc(sizeof(float)*npml);	    \
  bzero(Ex,sizeof(float)*nx*ny);		    \
  bzero(Ey,sizeof(float)*nx*ny);		    \
  bzero(Hzx,sizeof(float)*nx*ny);		    \
  bzero(Hzy,sizeof(float)*nx*ny);		    \
  bzero(Fx,sizeof(float)*nx*ny);		    \
  bzero(Fy,sizeof(float)*nx*ny);		    \
  bzero(Wp,sizeof(float)*nx*ny);		    \
  bzero(r,sizeof(float)*nx*ny);			    \
  bzero(Px,sizeof(float)*nx*ny);		    \
  bzero(Py,sizeof(float)*nx*ny);		    \
  bzero(sE,sizeof(float)*2*ny);			    \
  bzero(sHz,sizeof(float)*2*ny);		    \
  bzero(rE,sizeof(float)*2*ny);			    \
  bzero(rHz,sizeof(float)*2*ny);		    \
  bzero(eperm,sizeof(float)*nx*ny);		    \
  bzero(einf,sizeof(float)*nx*ny);		    \
  bzero(sigmax,sizeof(float)*nx*ny);		    \
  bzero(sigmay,sizeof(float)*nx*ny);

